/*
 * FTM.c
 *
 *  Created on: Sep 17, 2019
 *      Author: a0222913
 */


#include "derivative.h" /* include peripheral declarations SSKEAZ64M4 */
#include "BeaconTorch.h"
extern char delayFlag;
extern char timeOutFlag;

void timerInitial()
{
	SIM_SCGC |= SIM_SCGC_FTM0_MASK;/*Enable Clock for FTM0*/
	SIM_SCGC |= SIM_SCGC_FTM1_MASK;/*Enable Clock for FTM1*/
	FTM0_SC |= FTM_SC_PS(7);/*clock divided by 128, period = 21.3us*/
	FTM1_SC |= FTM_SC_PS(7);/*clock divided by 128, period = 21.3us*/
	/* Enable FTM0 interrupt */
	Enable_Interrupt(FTM0_IRQn);
	/* Enable FTM1 interrupt */
	Enable_Interrupt(FTM1_IRQn);

}

void delay(int delayTime) //50 = 1ms, maximum = 32767 (688ms)
{
	delayFlag=0;
	FTM0_CNT = delayTime;/*update CNTIN*/
	FTM0_MOD = delayTime;
	FTM0_SC |= FTM_SC_CLKS(1) + FTM_SC_TOIE_MASK; /*Select system clock to enable FTM0, and enable TOF interrupt*/
	do
	{
		;
	}while(delayFlag==0);
}

void timeOut(int timeOut) //50 = 1ms, maximum = 32767 (688ms)
{
	timeOutFlag=0;
	FTM1_CNT = timeOut;/*update CNTIN*/
	FTM1_MOD = timeOut;
	FTM1_SC |= FTM_SC_CLKS(1) + FTM_SC_TOIE_MASK; /*Select system clock to enable FTM1, and enable TOF interrupt*/
}

void FTM0_IRQHandler() /*Interrupt function of FTM0*/
{
	FTM0_SC &= ~FTM_SC_TOIE_MASK;/*disable FTM0 TOF interrupt*/
	FTM0_SC &= ~FTM_SC_TOF_MASK;/* Read to clear flag */
	FTM0_SC &= ~FTM_SC_CLKS_MASK;/*disable FTM0*/
	delayFlag=1;
}

void FTM1_IRQHandler() /*Interrupt function of FTM1*/
{
	FTM1_SC &= ~FTM_SC_TOIE_MASK;/*disable FTM1 TOF interrupt*/
	FTM1_SC &= ~FTM_SC_TOF_MASK;/* Read to clear flag */
	FTM1_SC &= ~FTM_SC_CLKS_MASK;/*disable FTM1*/
	timeOutFlag=1;
}
